#include <stdbool.h>
#include <smp.h>
#include <serial.h>
#include <printf.h>
#include <paging.h>
#include <video.h>
#include <acpi.h>
#include <panic.h>
#include <kernel.h>
#include <stdbool.h>
#include <int.h>
#include <io.h>
#include <cpuid.h>
#include <heap.h>
#include <random.h>
#include <timer.h>
#include <libc.h>

//testing headers
#include <testmalloc.h>


void multicore_main() {
  printf("\nKernal started\n");
  asm("cli\nhlt");
}

void main() {
#ifndef SCREEN_OUTPUT
  if(init_serial(COM1)) printf("\nKernal started on CPU 1!\n");
#endif
  get_mem_capabilities(); 
  init_pmap(map_complete_physical()); 
 
  
  find_root_sdp();
  debug_acpi();
  
  init_interrupts();

  
  randinit();

  smp_boot();
  fix_stack();
  unmap_lowmem();

  PANIC(KERNEL_PANIC_KERNEL_RETURNED);
}
